#version 330 compatibility

#include "/lib/distort.glsl"
#include "/lib/common.glsl"

uniform sampler2D gtexture;
uniform float alphaTestRef = 0.1;
uniform float far;

uniform sampler2D colortex0;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform mat4 gbufferProjectionInverse;

in vec2 texcoord;
in vec2 lmcoord;
in vec4 glcolor;
in vec3 normal;


vec3 projectAndDivide(mat4 projectionMatrix, vec3 position){
  vec4 homPos = projectionMatrix * vec4(position, 1.0);
  return homPos.xyz / homPos.w;
}

/* RENDERTARGETS: 0 */
layout(location = 0) out vec4 color;

void main() {

  color = texture(gtexture, texcoord) * glcolor * vec4(1.0, 1.0, 1.0, 0.794);
	
	if (color.a < alphaTestRef) {
		discard;
	}

	float depth = texture(depthtex0, texcoord).r;
			if(depth == 1.0)
			{
				return;
			}

 vec3 NDCPos = vec3(texcoord.xy, depth) * 2.0 - 1.0;
  vec3 viewPos = projectAndDivide(gbufferProjectionInverse, NDCPos);


	// Fog calculations
  float dist = length(viewPos) / far;
  float fogFactor = exp(-FOG_DENSITY * (1.0 - dist));
  vec3 waterfogColor = vec3(1.0, 1.0, 1.0);


	

}